diff --git a/storage/innobase/lock/lock0lock.cc b/storage/innobase/lock/lock0lock.cc
index 5e6cfe3..d1cdfd4 100644
--- a/storage/innobase/lock/lock0lock.cc
+++ b/storage/innobase/lock/lock0lock.cc
@@ -206,7 +206,11 @@ bool lock_check_trx_id_sanity(
 {
   ut_ad(rec_offs_validate(rec, index, offsets));
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_id_t max_trx_id = trx_sys->get_max_trx_id();
+#else
   trx_id_t max_trx_id = trx_sys_get_max_trx_id();
+#endif /* HAVE_LOCK_FREE_READVIEW */
   bool is_ok = trx_id < max_trx_id;
 
   if (!is_ok) {
@@ -817,6 +821,9 @@ static const lock_t *lock_rec_other_has_conflicting(
  negatives. The caller must confirm all positive results by calling
  trx_is_active(). */
 static trx_t *lock_sec_rec_some_has_impl(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,    /*!< in/out: trx of current thread */
+#endif                    /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *rec,     /*!< in: user record */
     dict_index_t *index,  /*!< in: secondary index */
     const ulint *offsets) /*!< in: rec_get_offsets(rec, index) */
@@ -826,7 +833,9 @@ static trx_t *lock_sec_rec_some_has_impl(
   const page_t *page = page_align(rec);
 
   ut_ad(!lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(!trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
   ut_ad(!index->is_clustered());
   ut_ad(page_rec_is_user_rec(rec));
   ut_ad(rec_offs_validate(rec, index, offsets));
@@ -839,6 +848,21 @@ static trx_t *lock_sec_rec_some_has_impl(
   max trx id to the log, and therefore during recovery, this value
   for a page may be incorrect. */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (max_trx_id < trx_sys->get_min_trx_id()) {
+    trx = nullptr;
+
+  } else if (!lock_check_trx_id_sanity(max_trx_id, rec, index, offsets)) {
+    /* The page is corrupt: try to avoid a crash by returning 0 */
+    trx = nullptr;
+
+    /* In this case it is possible that some transaction has an implicit
+    x-lock. We have to look in the clustered index. */
+
+  } else {
+    trx = row_vers_impl_x_locked(caller_trx, rec, index, offsets);
+  }
+#else
   if (max_trx_id < trx_rw_min_trx_id() && !recv_recovery_is_on()) {
     trx = 0;
 
@@ -852,11 +876,60 @@ static trx_t *lock_sec_rec_some_has_impl(
   } else {
     trx = row_vers_impl_x_locked(rec, index, offsets);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   return (trx);
 }
 
 #ifdef UNIV_DEBUG
+#ifdef HAVE_LOCK_FREE_READVIEW
+struct lock_rec_other_trx_holds_expl_arg {
+  ulint precise_mode;
+  const buf_block_t *const block;
+  ulint heap_no;
+  const trx_t *impl_trx;
+};
+
+static bool lock_rec_other_trx_holds_expl_callback(
+    rw_trx_hash_element_t *element, lock_rec_other_trx_holds_expl_arg *arg) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    const lock_t *expl_lock = lock_rec_has_expl(arg->precise_mode, arg->block,
+                                                arg->heap_no, arg->impl_trx);
+
+    ut_ad(!expl_lock || expl_lock->trx == arg->impl_trx);
+  }
+  mutex_exit(&element->mutex);
+  return false;
+}
+
+/** Checks if some transaction, other than given trx_id, has an explicit
+ lock on the given rec, in the given precise_mode. */
+static void lock_rec_other_trx_holds_expl(
+    trx_t *caller_trx,        /*!< in: current transaction */
+    ulint precise_mode,       /*!< in: LOCK_S or LOCK_X
+                              possibly ORed to LOCK_GAP or
+                              LOCK_REC_NOT_GAP. */
+    trx_t *trx,               /*!< in: trx holding implicit
+                              lock on rec */
+    const rec_t *rec,         /*!< in: user record */
+    const buf_block_t *block) /*!< in: buffer block
+                              containing the record */
+{
+  lock_mutex_enter();
+
+  ulint heap_no = page_rec_get_heap_no(rec);
+  lock_rec_other_trx_holds_expl_arg arg = {precise_mode, block, heap_no, trx};
+
+  trx_sys->rw_trx_hash.iterate(caller_trx,
+                               reinterpret_cast<lf_hash_walk_func *>(
+                                   lock_rec_other_trx_holds_expl_callback),
+                               &arg);
+
+  lock_mutex_exit();
+}
+#else
 /** Checks if some transaction, other than given trx_id, has an explicit
  lock on the given rec, in the given precise_mode.
 @param[in]   precise_mode   LOCK_S or LOCK_X possibly ORed to LOCK_GAP or
@@ -904,6 +977,7 @@ static bool lock_rec_other_trx_holds_expl(ulint precise_mode, const trx_t *trx,
 
   return (holds);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 #endif /* UNIV_DEBUG */
 
 /** Return approximate number or record locks (bits set in the bitmap) for
@@ -4382,6 +4456,83 @@ static void lock_remove_all_on_table_for_trx(
   trx_mutex_exit(trx);
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+struct lock_remove_recovered_trx_record_locks_arg {
+  dict_table_t *table;
+  ulint n_recovered_trx;
+};
+
+static bool lock_remove_recovered_trx_record_locks_callback(
+    rw_trx_hash_element_t *element,
+    lock_remove_recovered_trx_record_locks_arg *arg) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    if (!trx->is_recovered) {
+      mutex_exit(&element->mutex);
+      return false;
+    }
+
+    /* Because we are holding the lock_sys->mutex,
+    implicit locks cannot be converted to explicit ones
+    while we are scanning the explicit locks. */
+
+    for (lock_t *lock = UT_LIST_GET_FIRST(trx->lock.trx_locks); lock != nullptr;
+         lock = UT_LIST_GET_NEXT(trx_locks, lock)) {
+      ut_a(lock->trx == trx);
+
+      /* Recovered transactions can't wait on a lock. */
+
+#ifdef HAVE_SCALABLE_LOCK_MGR
+      ut_a(!lock->is_waiting());
+#else
+      ut_a(!lock_get_wait(lock));
+#endif /* HAVE_SCALABLE_LOCK_MGR */
+
+      switch (lock_get_type_low(lock)) {
+        default:
+          ut_error;
+        case LOCK_TABLE:
+          if (lock->tab_lock.table == arg->table) {
+            lock_trx_table_locks_remove(lock);
+            lock_table_remove_low(lock);
+          }
+          break;
+        case LOCK_REC:
+          if (lock->index->table == arg->table) {
+            lock_rec_discard(lock);
+          }
+      }
+    }
+
+    ++arg->n_recovered_trx;
+  }
+  mutex_exit(&element->mutex);
+  return false;
+}
+
+/** Remove any explicit record locks held by recovering transactions on
+ the table.
+ @return number of recovered transactions examined */
+static ulint lock_remove_recovered_trx_record_locks(
+    dict_table_t *table) /*!< in: check if there are any locks
+                         held on records in this table or on the
+                         table itself */
+{
+  ut_a(table != nullptr);
+  ut_ad(lock_mutex_own());
+
+  lock_remove_recovered_trx_record_locks_arg arg = {table, 0};
+
+  trx_sys->rw_trx_hash.iterate(
+      reinterpret_cast<lf_hash_walk_func *>(
+          lock_remove_recovered_trx_record_locks_callback),
+      &arg);
+
+  return (arg.n_recovered_trx);
+}
+#else
+
 /** Remove any explicit record locks held by recovering transactions on
  the table.
  @return number of recovered transactions examined */
@@ -4452,6 +4603,7 @@ static ulint lock_remove_recovered_trx_record_locks(
 
   return (n_recovered_trx);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Removes locks on a table to be dropped.
  If remove_also_table_sx_locks is true then table-level S and X locks are
@@ -4709,7 +4861,11 @@ bool lock_print_info_summary(
       "------------\n",
       file);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  fprintf(file, "Trx id counter " TRX_ID_FMT "\n", trx_sys->get_max_trx_id());
+#else
   fprintf(file, "Trx id counter " TRX_ID_FMT "\n", trx_sys_get_max_trx_id());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   fprintf(file,
           "Purge done for trx's n:o < " TRX_ID_FMT " undo n:o < " TRX_ID_FMT
@@ -4766,7 +4922,9 @@ struct PrintNotStarted {
   void operator()(const trx_t *trx) {
     /* We require exclusive access to lock_sys */
     ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
     ut_ad(trx->in_mysql_trx_list);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     ut_ad(mutex_own(&trx_sys->mutex));
 
     /* See state transitions and locking rules in trx0trx.h */
@@ -4818,6 +4976,7 @@ class TrxLockIterator {
   ulint m_index;
 };
 
+#ifndef HAVE_LOCK_FREE_READVIEW
 /** This iterates over both the RW and RO trx_sys lists. We need to keep
 track where the iterator was up to and we do that using an ordinal value. */
 
@@ -4875,6 +5034,7 @@ class TrxListIterator {
   /** For iterating over a transaction's locks */
   TrxLockIterator m_lock_iter;
 };
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Prints transaction lock wait and MVCC state.
 @param[in,out]	file	file where to print
@@ -4887,11 +5047,22 @@ void lock_trx_print_wait_and_mvcc_state(FILE *file, const trx_t *trx) {
 
   trx_print_latched(file, trx, 600);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  /* Note: read_view->get_state() check is race condition. But it
+  should "kind of work" because read_view is freed only at shutdown.
+  Worst thing that may happen is that it'll get transferred to
+  another thread and print wrong values. */
+
+  if (READ_VIEW_STATE_OPEN == trx->read_view.get_state()) {
+    trx->read_view.print_limits(file);
+  }
+#else
   const ReadView *read_view = trx_get_read_view(trx);
 
   if (read_view != NULL) {
     read_view->print_limits(file);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   if (trx->lock.que_state == TRX_QUE_LOCK_WAIT) {
     fprintf(file,
@@ -4909,6 +5080,65 @@ void lock_trx_print_wait_and_mvcc_state(FILE *file, const trx_t *trx) {
   }
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** Prints info of locks for a transaction.
+ @return true if all printed, false if latches were released. */
+static void lock_trx_print_locks(
+    FILE *file,       /*!< in/out: File to write */
+    const trx_t *trx) /*!< in: current transaction */
+{
+  const lock_t *lock;
+  uint32_t i = 0;
+
+  /* Iterate over the transaction's locks. */
+  for (lock = UT_LIST_GET_FIRST(trx->lock.trx_locks); lock != nullptr;
+       lock = UT_LIST_GET_NEXT(trx_locks, lock)) {
+    if (lock_get_type_low(lock) == LOCK_REC) {
+      /* Print all the record locks on the page from
+      the record lock bitmap */
+
+      lock_rec_print(file, lock);
+    } else {
+      ut_ad(lock_get_type_low(lock) & LOCK_TABLE);
+
+      lock_table_print(file, lock);
+    }
+
+    if (++i == 10) {
+      fprintf(file,
+              "10 LOCKS PRINTED FOR THIS TRX:"
+              " SUPPRESSING FURTHER PRINTS\n");
+
+      break;
+    }
+  }
+}
+
+static bool lock_print_info_all_transactions_callback(
+    rw_trx_hash_element_t *element, FILE *file) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    check_trx_state(trx);
+
+    lock_trx_print_wait_and_mvcc_state(file, trx);
+
+    /* If we need to print the locked record contents then we
+    need to fetch the containing block from the buffer pool. */
+    if (srv_print_innodb_lock_monitor) {
+      /* Print the locks owned by the current transaction. */
+
+      trx->reference();
+      mutex_exit(&element->mutex);
+      lock_trx_print_locks(file, trx);
+      trx->release_reference();
+      return false;
+    }
+  }
+  mutex_exit(&element->mutex);
+  return false;
+}
+#else
 /** Prints info of locks for a transaction. This function will release the
  lock mutex and the trx_sys_t::mutex if the page was read from disk.
  @return true if page was read from the tablespace */
@@ -5019,6 +5249,7 @@ static bool lock_trx_print_locks(
 
   return (true);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Prints info of locks for each transaction. This function assumes that the
  caller holds the lock mutex and more importantly it will release the lock
@@ -5031,7 +5262,9 @@ void lock_print_info_all_transactions(
 
   fprintf(file, "LIST OF TRANSACTIONS FOR EACH SESSION:\n");
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   mutex_enter(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* First print info on non-active transactions */
 
@@ -5040,6 +5273,15 @@ void lock_print_info_all_transactions(
   available from INFORMATION_SCHEMA.INNODB_TRX. */
 
   PrintNotStarted print_not_started(file);
+#ifdef HAVE_LOCK_FREE_READVIEW
+  mutex_enter(&trx_sys->mutex);
+  ut_list_map(trx_sys->trx_list, print_not_started);
+  mutex_exit(&trx_sys->mutex);
+  trx_sys->rw_trx_hash.iterate(
+      reinterpret_cast<lf_hash_walk_func *>(
+          lock_print_info_all_transactions_callback),
+      file);
+#else
   ut_list_map(trx_sys->mysql_trx_list, print_not_started);
 
   const trx_t *trx;
@@ -5089,9 +5331,12 @@ void lock_print_info_all_transactions(
     a page from disk, or we didn't need to print the detail. */
     trx_iter.next();
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   lock_mutex_exit();
+#ifndef HAVE_LOCK_FREE_READVIEW
   mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   ut_ad(lock_validate());
 }
@@ -5125,7 +5370,9 @@ static bool lock_table_queue_validate(
   const lock_t *lock;
 
   ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   for (lock = UT_LIST_GET_FIRST(table->locks); lock != NULL;
        lock = UT_LIST_GET_NEXT(tab_lock.locks, lock)) {
@@ -5209,14 +5456,22 @@ static bool lock_rec_queue_validate(
 
     trx_id = lock_clust_rec_some_has_impl(rec, index, offsets);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    const trx_t *impl_trx = nullptr;
+    impl_trx =
+        (trx_id > 0) ? trx_sys->find(current_trx(), trx_id, false) : nullptr;
+#else
     const trx_t *impl_trx = trx_rw_is_active_low(trx_id, NULL);
+#endif /* HAVE_LOCK_FREE_READVIEW */
     if (impl_trx != nullptr) {
       ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
       ut_ad(trx_sys_mutex_own());
       /* impl_trx cannot become TRX_STATE_COMMITTED_IN_MEMORY nor removed from
       rw_trx_set until we release trx_sys->mutex, which means that currently all
       other threads in the system consider this impl_trx active and thus should
       respect implicit locks held by impl_trx*/
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
       const lock_t *other_lock =
           lock_rec_other_has_expl_req(LOCK_S, block, true, heap_no, impl_trx);
@@ -5347,6 +5602,38 @@ function_exit:
   return (true);
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+static bool lock_validate_table_locks_callback(rw_trx_hash_element_t *element,
+                                               void * /*unused*/) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    const lock_t *lock = nullptr;
+
+    check_trx_state(trx);
+
+    for (lock = UT_LIST_GET_FIRST(trx->lock.trx_locks); lock != nullptr;
+         lock = UT_LIST_GET_NEXT(trx_locks, lock)) {
+      if ((lock_get_type_low(lock) & LOCK_TABLE) != 0u) {
+        lock_table_queue_validate(lock->tab_lock.table);
+      }
+    }
+  }
+  mutex_exit(&element->mutex);
+  return false;
+}
+
+/** Validates the table locks.
+ @return true if ok */
+static bool lock_validate_table_locks() {
+  ut_ad(lock_mutex_own());
+  trx_sys->rw_trx_hash.iterate(
+      reinterpret_cast<lf_hash_walk_func *>(lock_validate_table_locks_callback),
+      nullptr);
+
+  return (true);
+}
+#else
 /** Validates the table locks.
  @return true if ok */
 static bool lock_validate_table_locks(
@@ -5376,6 +5663,7 @@ static bool lock_validate_table_locks(
 
   return (true);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Validate record locks up to a limit.
  @return lock at limit or NULL if no more locks in the hash bucket */
@@ -5386,7 +5674,9 @@ static MY_ATTRIBUTE((warn_unused_result)) const lock_t *lock_rec_validate(
                      (space, page_no) */
 {
   ut_ad(lock_mutex_own());
+#ifndef HAVE_LOCK_FREE_READVIEW
   ut_ad(trx_sys_mutex_own());
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   for (const lock_t *lock = static_cast<const lock_t *>(
            HASH_GET_FIRST(lock_sys->rec_hash, start));
@@ -5447,9 +5737,13 @@ static bool lock_validate() {
   page_addr_set pages;
 
   lock_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_a(lock_validate_table_locks());
+#else
   mutex_enter(&trx_sys->mutex);
 
   ut_a(lock_validate_table_locks(&trx_sys->rw_trx_list));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* Iterate over all the record locks and validate the locks. We
   don't want to hog the lock_sys_t::mutex and the trx_sys_t::mutex.
@@ -5469,7 +5763,9 @@ static bool lock_validate() {
     }
   }
 
+#ifndef HAVE_LOCK_FREE_READVIEW
   mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   lock_mutex_exit();
 
   for (page_addr_set::const_iterator it = pages.begin(); it != pages.end();
@@ -5635,7 +5931,11 @@ static void lock_rec_convert_impl_to_expl_for_trx(
     trx_t *trx,               /*!< in/out: active transaction */
     ulint heap_no)            /*!< in: rec heap number to lock */
 {
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx->is_referenced());
+#else
   ut_ad(trx_is_referenced(trx));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   DEBUG_SYNC_C("before_lock_rec_convert_impl_to_expl_for_trx");
 
@@ -5688,11 +5988,80 @@ static void lock_rec_convert_impl_to_expl_for_trx(
   lock_mutex_exit();
   trx_mutex_exit(trx);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->release_reference();
+#else
   trx_release_reference(trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   DEBUG_SYNC_C("after_lock_rec_convert_impl_to_expl_for_trx");
 }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** If a transaction has an implicit x-lock on a record, but no explicit x-lock
+set on the record, sets one for it.
+@param[in,out] caller_trx    current transaction
+@param[in]        block         buffer block of rec
+@param[in]        rec                 user record on page
+@param[in]        index                     index of record
+@param[in]        offsets                 rec_get_offsets(rec, index)
+@return whether caller_trx already holds an exclusive lock on rec */
+static bool lock_rec_convert_impl_to_expl(trx_t *caller_trx,
+                                          const buf_block_t *block,
+                                          const rec_t *rec, dict_index_t *index,
+                                          const ulint *offsets) {
+  trx_t *trx;
+
+  ut_ad(!lock_mutex_own());
+  ut_ad(page_rec_is_user_rec(rec));
+  ut_ad(rec_offs_validate(rec, index, offsets));
+  ut_ad(!page_rec_is_comp(rec) == !rec_offs_comp(offsets));
+
+  if (index->is_clustered()) {
+    trx_id_t trx_id;
+
+    trx_id = lock_clust_rec_some_has_impl(rec, index, offsets);
+
+   if (trx_id == 0) {
+      return false;
+    }
+    if (UNIV_UNLIKELY(trx_id == caller_trx->id)) {
+      return true;
+    }
+
+    trx = trx_sys->find(caller_trx, trx_id);
+  } else {
+    ut_ad(!dict_index_is_online_ddl(index));
+
+    trx = lock_sec_rec_some_has_impl(caller_trx, rec, index, offsets);
+    if (trx == caller_trx) {
+      trx->release_reference();
+      return true;
+    }
+
+    if (trx != nullptr) {
+      DEBUG_SYNC_C("lock_rec_convert_impl_to_expl_will_validate");
+      ut_d(lock_rec_other_trx_holds_expl(caller_trx, LOCK_S | LOCK_REC_NOT_GAP,
+                                         trx, rec, block));
+    }
+  }
+
+  if (trx != nullptr) {
+    ulint heap_no = page_rec_get_heap_no(rec);
+
+    ut_ad(trx->is_referenced());
+
+    /* If the transaction is still active and has no
+    explicit x-lock set on the record, set one for it.
+    trx cannot be committed until the ref count is zero. */
+
+    lock_rec_convert_impl_to_expl_for_trx(block, rec, index, offsets, trx,
+                                          heap_no);
+  }
+
+  return false;
+}
+#else
 /** If a transaction has an implicit x-lock on a record, but no explicit x-lock
 set on the record, sets one for it.
 @param[in]	block		buffer block of rec
@@ -5741,12 +6110,17 @@ static void lock_rec_convert_impl_to_expl(const buf_block_t *block,
                                           heap_no);
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 void lock_rec_convert_active_impl_to_expl(const buf_block_t *block,
                                           const rec_t *rec, dict_index_t *index,
                                           const ulint *offsets, trx_t *trx,
                                           ulint heap_no) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->reference();
+#else
   trx_reference(trx, true);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   lock_rec_convert_impl_to_expl_for_trx(block, rec, index, offsets, trx,
                                         heap_no);
 }
@@ -5786,7 +6160,15 @@ dberr_t lock_clust_rec_modify_check_and_lock(
   /* If a transaction has no explicit x-lock set on the record, set one
   for it */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (lock_rec_convert_impl_to_expl(thr_get_trx(thr), block, rec, index,
+                                    offsets)) {
+    /* We already hold an implicit exclusive lock. */
+    return DB_SUCCESS;
+  }
+#else
   lock_rec_convert_impl_to_expl(block, rec, index, offsets);
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   lock_mutex_enter();
 
@@ -5909,11 +6291,23 @@ dberr_t lock_sec_rec_read_check_and_lock(
   if the max trx id for the page >= min trx id for the trx list or a
   database recovery is running. */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if ((page_get_max_trx_id(block->frame) >= trx_sys->get_min_trx_id() ||
+       recv_recovery_is_on()) &&
+      page_rec_is_supremum(rec) == 0u) {
+    if (lock_rec_convert_impl_to_expl(thr_get_trx(thr), block, rec, index,
+                                      offsets)) {
+      /* We already hold an implicit exclusive lock. */
+      return DB_SUCCESS;
+    }
+  }
+#else
   if ((page_get_max_trx_id(block->frame) >= trx_rw_min_trx_id() ||
        recv_recovery_is_on()) &&
       !page_rec_is_supremum(rec)) {
     lock_rec_convert_impl_to_expl(block, rec, index, offsets);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   lock_mutex_enter();
 
@@ -5962,7 +6356,15 @@ dberr_t lock_clust_rec_read_check_and_lock(
   heap_no = page_rec_get_heap_no(rec);
 
   if (heap_no != PAGE_HEAP_NO_SUPREMUM) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    if (lock_rec_convert_impl_to_expl(thr_get_trx(thr), block, rec, index,
+                                      offsets)) {
+      /* We already hold an implicit exclusive lock. */
+      return DB_SUCCESS;
+    }
+#else
     lock_rec_convert_impl_to_expl(block, rec, index, offsets);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
   DEBUG_SYNC_C("after_lock_clust_rec_read_check_and_lock_impl_to_expl");
@@ -6408,8 +6810,13 @@ void lock_trx_release_locks(trx_t *trx) /*!< in/out: transaction */
   check_trx_state(trx);
   ut_ad(trx_state_eq(trx, TRX_STATE_COMMITTED_IN_MEMORY));
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  if (trx->is_referenced()) {
+    while (trx->is_referenced()) {
+#else
   if (trx_is_referenced(trx)) {
     while (trx_is_referenced(trx)) {
+#endif /* HAVE_LOCK_FREE_READVIEW */
       trx_mutex_exit(trx);
 
       DEBUG_SYNC_C("waiting_trx_is_not_referenced");
@@ -6422,7 +6829,11 @@ void lock_trx_release_locks(trx_t *trx) /*!< in/out: transaction */
     }
   }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(!trx->is_referenced());
+#else
   ut_ad(!trx_is_referenced(trx));
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /* If the background thread trx_rollback_or_clean_recovered()
   is still active then there is a chance that the rollback
@@ -6496,6 +6907,61 @@ dberr_t lock_trx_handle_wait(trx_t *trx) /*!< in/out: trx lock state */
 }
 
 #ifdef UNIV_DEBUG
+#ifdef HAVE_LOCK_FREE_READVIEW
+struct lock_table_locks_lookup_arg {
+  const dict_table_t *table;
+  const lock_t *lock;
+};
+
+static bool lock_table_locks_lookup_callback(rw_trx_hash_element_t *element,
+                                             lock_table_locks_lookup_arg *arg) {
+  mutex_enter(&element->mutex);
+  trx_t *trx = element->trx;
+  if (trx != nullptr) {
+    const lock_t *lock = nullptr;
+
+    check_trx_state(trx);
+
+    for (lock = UT_LIST_GET_FIRST(trx->lock.trx_locks); lock != nullptr;
+         lock = UT_LIST_GET_NEXT(trx_locks, lock)) {
+      ut_a(lock->trx == trx);
+
+      if (lock_get_type_low(lock) == LOCK_REC) {
+        ut_ad(!dict_index_is_online_ddl(lock->index) ||
+              lock->index->is_clustered());
+        if (lock->index->table == arg->table) {
+          arg->lock = lock;
+          break;
+        }
+      } else if (lock->tab_lock.table == arg->table) {  // NOLINT
+        arg->lock = lock;
+        break;
+      }
+    }
+  }
+  mutex_exit(&element->mutex);
+  return (arg->lock != nullptr);
+}
+
+/** Do an exhaustive check for any locks (table or rec) against the table.
+ @return lock if found */
+static const lock_t *lock_table_locks_lookup(
+    const dict_table_t *table) /*!< in: check if there are
+                               any locks held on records in
+                               this table or on the table
+                               itself */
+{
+  ut_a(table != nullptr);
+
+  lock_table_locks_lookup_arg arg = {table, nullptr};
+
+  trx_sys->rw_trx_hash.iterate(
+      reinterpret_cast<lf_hash_walk_func *>(lock_table_locks_lookup_callback),
+      &arg);
+
+  return (arg.lock);
+}
+#else
 /** Do an exhaustive check for any locks (table or rec) against the table.
  @return lock if found */
 static const lock_t *lock_table_locks_lookup(
@@ -6535,6 +7001,7 @@ static const lock_t *lock_table_locks_lookup(
 
   return (NULL);
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 #endif /* UNIV_DEBUG */
 
 /** Check if there are any locks (table or rec) against table.
@@ -6552,11 +7019,15 @@ bool lock_table_has_locks(
 
 #ifdef UNIV_DEBUG
   if (!has_locks) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    ut_ad(lock_table_locks_lookup(table) == nullptr);
+#else
     mutex_enter(&trx_sys->mutex);
 
     ut_ad(!lock_table_locks_lookup(table, &trx_sys->rw_trx_list));
 
     mutex_exit(&trx_sys->mutex);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 #endif /* UNIV_DEBUG */
 
diff --git a/storage/innobase/page/page0page.cc b/storage/innobase/page/page0page.cc
index 70521c3..e429953 100644
--- a/storage/innobase/page/page0page.cc
+++ b/storage/innobase/page/page0page.cc
@@ -2180,7 +2180,11 @@ ibool page_validate(
     trx_id_t max_trx_id = page_get_max_trx_id(page);
     /* This will be 0 during recv_apply_hashed_log_recs(TRUE),
     because the transaction system has not been initialized yet */
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_id_t sys_max_trx_id = trx_sys->get_max_trx_id();
+#else
     trx_id_t sys_max_trx_id = trx_sys_get_max_trx_id();
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
     if (max_trx_id == 0 ||
         (sys_max_trx_id != 0 && max_trx_id > sys_max_trx_id)) {
